#include <CapacitiveSensor.h>     // Changer la librarie pour les capteurs capacitifs
#include <Tone.h>                 // Changer la librarie tone

CapacitiveSensor cs_4_2 = CapacitiveSensor(4,2);     // Brancher une resistance de 1 a 10MOhm entre les pin 4 & 2, pin 2 est le capteur capacitif
CapacitiveSensor cs_4_6 = CapacitiveSensor(4,6);     // Brancher une resistance de 1 a 10MOhm entre les pin 4 & 6, pin 6 est le capteur capacitif
CapacitiveSensor cs_4_8 = CapacitiveSensor(4,8);     // Brancher une resistance de 1 a 10MOhm entre les pin 4 & 8, pin 8 est le capteur capacitif

int led1 = 10;             // brancher une led sur la pin 10
int led2 = 11;             // brancher une led sur la pin 11
int led3 = 12;             // brancher une led sur la pin 12
int X = 250;               // Définir le seul du capteur capacitif
int debut = 700;           // Définir une durée de son
int son = 100;             // Définir une durée de fin
int duree = 500;           // Définir une durée de base
int tmp = duree;           // Stocker la valeur duree de base
int score = 0;             // Définir un score de base
long randPin;              // Définir une variable pour le random
boolean finDeJeu = true;   // Définir une position fin de jeu
boolean bon = false;

Tone note;         // Utiliser la librairie tone


////////////////////SETUP///////////////////////////
void setup() {
cs_4_2.set_CS_AutocaL_Millis(0xFFFFFFFF);   // mettre en pause la calibration automatique
note.begin(9);                              // utiliser la librarie note sur la pin digitale 9
pinMode(led1, OUTPUT);                      // definir que la led est une sortie
pinMode(led2, OUTPUT);                      // definir que la led est une sortie
pinMode(led3, OUTPUT);                      // definir que la led est une sortie
Serial.begin(9600);                         // Transmettre des donees sur le port serie
}


//////////////////////LOOP///////////////////////////
void loop() {

long start = millis();
long total1 = cs_4_2.capacitiveSensor(30); //lire les information du capteur capacitif pin 2
long total2 = cs_4_6.capacitiveSensor(30); //lire les information du capteur capacitif pin 6
long total3 = cs_4_8.capacitiveSensor(30); //lire les information du capteur capacitif pin 8 


if (total1>X && total2>X && total3>X) {  // Si on appuie sur les 3 capteurs en meme temps
digitalWrite(led1, HIGH);                // on allume les 3 LED
digitalWrite(led2, HIGH);
digitalWrite(led3, HIGH);
meldeb();                                // Puis on joue meldeb
digitalWrite(led1, LOW);                 // Puis on eteint les 3 LED
digitalWrite(led2, LOW);
digitalWrite(led3, LOW);
duree = tmp;                             // Puis on réinitialise la duree
score = 0;                               // Puis on réinitialise le score à 0
delay(debut);
finDeJeu = false;                        // Puis on enclanche la Partie
}

if (finDeJeu == true){                   // Si on est en finDeJeu
  finDePartie();                         // Game Over
}
else {                                   // Sinon on lance la partie
aleatoireLed();                          // En lançant la fonction aléatoire
delay(duree*2);                         

// Si random = 2 et la resistance 2 est touchée :
if (randPin == 1 && (cs_4_2.capacitiveSensor(30))>X) {
note.play(NOTE_C4);                     // On joue un DO         
delay(duree);
bon = true;                             // On signale que la bonne note est touchée         
duree -= (duree/14);                    // On augmente la vitesse du jeu en enlevant 1/14 de la durée
score += 200;                           // On augmente le score de 200 points
note.stop();                            // Puis on arrete de jouer la note
}

// Si random = 2 et la resistance 2 est touchée :
if (randPin == 2 && (cs_4_6.capacitiveSensor(30))>X) {
note.play(NOTE_D4);                     // Pareil que plus haut avec un Ré
delay(duree);
bon = true;
duree -= (duree/14);
score += 200;
note.stop();
}

// Si random = 3 et la resistance 3 est touchée :
if (randPin == 3 && (cs_4_8.capacitiveSensor(30))>X) {
note.play(NOTE_E4);                     // Pareil que plus haut avec un Mi
delay(duree);
bon = true;
duree -= (duree/14);
score += 200;
note.stop();
}
delay(duree);
if (bon == false) {                      // Si aucune note est touchée
finDeJeu = true;                         // Game Over

digitalWrite(led1, HIGH);                // On allume toutes les lumières
digitalWrite(led2, HIGH);
digitalWrite(led3, HIGH);
melfin();                                // On joue la mélodie de fin
digitalWrite(led1, LOW);                 // On éteint tout
digitalWrite(led2, LOW);
digitalWrite(led3, LOW);
Serial.println(score);                   // On envoie le score au Sérial
  
}
else{                                    // Sinon on remet le capteur note à faux pour la prochaine note
bon = false;                             // Et on éteint les Leds
digitalWrite(led1, LOW);
digitalWrite(led2, LOW);
digitalWrite(led3, LOW);
delay(100);
}

}
}

////////////////////FONCTIONS///////////////////////////

//fonction d'allumage aléatoire des LEDs
void aleatoireLed(){

randPin = random(1, 4);                    // choisit une valeur entre 1, 2 et 3
// Si random = 1, allumer la led 1
if (randPin == 1) {
digitalWrite(led1, HIGH);
digitalWrite(led2, LOW);
digitalWrite(led3, LOW);
}
// Si random = 2, allumer la led 2
if (randPin == 2) {
digitalWrite(led1, LOW);
digitalWrite(led2, HIGH);
digitalWrite(led3, LOW);
}
// Si random = 3, allumer la led 3
if (randPin == 3) {
digitalWrite(led1, LOW);
digitalWrite(led2, LOW);
digitalWrite(led3, HIGH);
}
}

// fonction de fin de Partie éteint toutes les Leds et le speaker
void finDePartie(){
digitalWrite(led1, LOW); 
digitalWrite(led2, LOW);
digitalWrite(led3, LOW);
note.stop();
}

// fonction de mélodie pour le début de la partie
void meldeb(){ 
note.play(NOTE_C4);
delay(son);
note.stop();
note.play(NOTE_E4);
delay(son);
note.stop();
note.play(NOTE_B4);
delay(son);
note.stop();
note.play(NOTE_A4);
delay(son);
note.stop();
}

// fonction de mélodie pour la fin de la partie
void melfin(){
note.play(NOTE_B4);
delay(son);
note.stop();
note.play(NOTE_E3);
delay(son*2);
note.stop();
note.play(NOTE_A3);
delay(son*4);
note.stop();
note.play(NOTE_A2);
delay(son*8);
note.stop();
}

